class iaas::profile::keepalived (
  $admin_interface = hiera('iaas::admin_interface', undef),
  $vip_address = hiera('iaas::role::endpoint::main_address',undef),
  $notification_email = undef,
  $notification_email_from = undef,
  $smtp_server = undef,
  $state = undef,
  $priority = undef,
  $lvs_interface = hiera('iaas::profile::keepalived::lvs_interface',undef),
) {

sysctl::value { "net.ipv4.ip_nonlocal_bind": value => "1" }

include keepalived

  class { 'keepalived::global_defs':
    ensure                  => present,
    notification_email      => $notification_email,
    notification_email_from => $notification_email_from,
    smtp_server             => $smtp_server,
    smtp_connect_timeout    => '60',
    router_id		    => '51',
  } ->

  keepalived::vrrp::script {'chk_haproxy':
    interval          => '1',
    weight            => '3',
    script            => 'killall -0 haproxy',
  } ->

  keepalived::vrrp::instance { 'VI_1':
    interface         => $admin_interface,
    state             => $state,
    virtual_router_id => '21',
    priority          => $priority,
    auth_type         => 'PASS',
    auth_pass         => '1111',
    virtual_ipaddress => $vip_address,
    lvs_interface => $lvs_interface,
    track_script      => 'chk_haproxy',
  } ->

  class { '::keepalived':
    service_restart => 'service keepalived reload',     # When using SysV Init
  }

}
